
#include "TROOT.h"
#include "TFile.h"
#include "TTree.h"
#include "TCanvas.h"
#include "TH1F.h"
#include "TSystem.h"

#include "CDataSample.hh"

static const Int_t kUPDATE = 100;
static const Int_t N = 1000;

void read() 
{
   TFile *f = TFile::Open("root/run0007.root","READ");
   TTree *t; f->GetObject("Koyomi",t);

   CDataSample* data = 0;
   TBranch *bdata = 0;
   t->SetBranchAddress("branchname",&data,&bdata);

   TH1F *h = new TH1F("h","This is the CDataSample::deque_d distribution",100,-4,4);
   TCanvas *c = new TCanvas("c1","Dynamic Filling Example",200,10,700,500);

#if 0
   for (Int_t i = 0; i < N; i++) {
      Long64_t tentry = t->LoadTree(i);
      bdata->GetEntry(tentry);
      
      std::deque<double>::iterator it = data->deque_d.begin();
      while(it != data->deque_d.end()){
	h->Fill(*it);
	++it;
      }

      if (i && (i%kUPDATE) == 0) {
         if (i == kUPDATE) h->Draw();
         c->Modified();
         c->Update();
         if (gSystem->ProcessEvents()) break;
      }
   }

   t->ResetBranchAddresses();
}
#endif

#if 1
   for (Int_t i = 0; i < N; i++) {
      Long64_t tentry = t->LoadTree(i);
      bdata->GetEntry(tentry);

      h->Reset();
      
      std::deque<double>::iterator it = data->deque_d.begin();
      while(it != data->deque_d.end()){
	h->Fill(*it);
	++it;
      }

      if(i%kUPDATE == 0){
	h->Draw();
	c->Update();
	if (gSystem->ProcessEvents()) break;
      }
   }

   t->ResetBranchAddresses();
}
#endif
